<template>
  <div class="view_menu">
    <div class="view_menu_fixed">
      <div
        class="card"
        id="curso"
        :style="renderSelected('curso')"
        @click="select($event)">
        <fa :icon="menuIcon"/>
        {{ menuText }}
      </div>

      <div
        v-show="isAuthenticated"
        class="card"
        id='disciplinas'
        :style="renderSelected('disciplinas')"
        @click="select($event)">
        &#9989; Disciplinas Realizadas
      </div>

    </div>

    <div class="view_menu_planos" v-show="isAuthenticated">
      <div v-for="plano of planos"
        class="card"
        :key="`plano_${plano}`"
        :id="`plano_${plano}`"
        :style="renderSelected(`plano_${plano}`)"
        @click="select($event)">
        Plano {{ plano }}
      </div>
    </div>
  </div>
</template>

<script>
import { mapGetters } from "vuex";

export default {
  props: ["planos"],

  data() {
    return {
      selected: "curso"
    };
  },

  methods: {
    async select(event) {
      this.selected = `${event.target.id}`;
      this.$store.commit("setView", { view: this.selected });

      if (this.selected === "disciplinas") {
        this.$store.commit("setPlannedCreditsToZero");
        this.$store.commit("setPlannedAsNull");
      } else if (this.selected.includes("plano")) {
        await this.$store.commit("setPlanNumber", {
          planNumber: this.selected.split("_")[1]
        });

        this.$store.dispatch("getActivePlan");
      }
    },

    renderSelected(element) {
      if (element === this.selected) {
        return `border-left: 0.8em solid #4F51B5`;
      }
    }
  },

  computed: {
    ...mapGetters([
      "isAuthenticated",
      "getUUID",
      "isOnIndex",
      "getPlanNumber"
    ]),

    menuText: function () {
      if(this.isAuthenticated)
        return 'Adicionar Plano'
      return 'Curso'
    },

    menuIcon: function () {
      if(this.isAuthenticated)
        return 'plus-square'
      return 'code'
    }
  }
};
</script>


<style lang="scss">
.view_menu {
  width: 100%;
}

.view_menu_fixed {
  margin-bottom: 1em;
}

.card {
  background-color: $light-color;
  color: $dark-color;
  padding: 1em 0 1em 1em;

  cursor: pointer;
  user-select: none;
}
</style>
